#include <rtt/TaskContext.hpp>

struct Foo : public RTT::TaskContext
{
  Foo(std::string name) : 
    RTT::TaskContext(name, PreOperational)
  {
  }

  bool configureHook(void)
  {
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
    m_flag_start = false;
    return true;
  }

  void cleanupHook(void)
  {
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
  }

  bool startHook(void)
  {
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
    // check non-periodic activity
    /*
    if(getActivity()->isPeriodic())
      {
        fprintf(stderr, "%s : periodic %f\n", __PRETTY_FUNCTION__, getActivity()->getPeriod());
      }
    else
      {
        fprintf(stderr, "%s : nonperiodic %f\n", __PRETTY_FUNCTION__, getActivity()->getPeriod());
      }
    */
    m_flag_update = true;
    m_flag_start = true;
    return true;
  }

  void stopHook(void)
  {
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
    m_flag_update = false;
  }

  void updateHook(void)
  {
    static int n = 0;
    int i = 0;
    assert(m_flag_start);
    n++;
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
    while(m_flag_update)
      {
        fprintf(stderr, "%s tick %d %d!\n", __PRETTY_FUNCTION__, n, i++);
        sleep(3);
      }
  }

  bool breakUpdateHook(void)
  {
    fprintf(stderr, "%s\n", __PRETTY_FUNCTION__);
    m_flag_update = false;
    return true;
  }

private :
  volatile bool m_flag_update;
  bool m_flag_start;
};

#include <ocl/Component.hpp>

// requires -DRTT_COMPONENT :
ORO_CREATE_COMPONENT( Foo );
